#include <qapplication.h>
#include "FocusWindow.h"

using namespace FW;

/**
 * @brief жĳؼǷΪĳϵĺѡؼ
 * @param focused ǰ۽Ŀؼȫλ
 * @param focusable ǰӵнĿؼȫλ
 * @param direction 
 * @return
 */
bool FocusWindow::isCandidate(QRect focused, QRect focusable, Direction direction)
{
	switch (direction)
	{
		case Up:
			return (focused.bottom() > focusable.bottom() || focused.top() >= focusable.bottom())
				&& focused.top() > focusable.top();
		case Down:
			return (focused.top() < focusable.top() || focused.bottom() <= focusable.top())
				&& focused.bottom() < focusable.bottom();
		case Left:
			return (focused.right() > focused.right() || focused.left() >= focusable.right())
				&& focused.left() > focusable.left();
		case Right:
			return (focused.left() < focusable.left() || focused.right() <= focusable.left())
				&& focused.right() < focusable.right();
		default:
			return false;
	}
}

/**
 * @brief жrect1rect2directionǷص
 * @param direction 
 * @param rect1 һ
 * @param rect2 ڶ
 * @return
 */
bool FocusWindow::beamsOverlap(Direction direction, QRect rect1, QRect rect2)
{
	switch (direction)
	{
		case Left:
		case Right:
			return (rect2.bottom() >= rect1.top()) && (rect2.top() <= rect1.bottom());
		case Up:
		case Down:
			return (rect2.right() >= rect1.left()) && (rect2.left() <= rect1.right());
	}
}

/**
 * @brief жdestǷsourcedirection
 * @param direction
 * @param source
 * @param dest
 * @return
 */
bool FocusWindow::isToDirectionOf(Direction direction, QRect source, QRect dest)
{
	switch (direction)
	{
		case Up:
			return source.top() >= dest.bottom();
		case Down:
			return source.bottom() <= dest.top();
		case Left:
			return source.left() >= dest.right();
		case Right:
			return source.right() <= dest.left();
	}
}

/**
 * @brief ᷽ϵľ
 * @param direction
 * @param source
 * @param dest
 * @return
 */
int FocusWindow::majorAxisDistance(Direction direction, QRect source, QRect dest)
{
	return qMax(0, majorAxisDistanceRaw(direction, source, dest));
}

/**
 * @brief ᷽ľ
 * @param direction
 * @param source
 * @param dest
 * @return
 */
int FocusWindow::majorAxisDistanceRaw(Direction direction, QRect source, QRect dest)
{
	switch (direction)
	{
		case Up:
			return source.top() - dest.bottom();
		case Down:
			return dest.top() - source.bottom();
		case Left:
			return source.left() - dest.right();
		case Right:
			return dest.left() - source.right();
		default:
			return 0;
	}
}

/**
 * @brief ᷽Ե
 * @param dircetion
 * @param source
 * @param dest
 * @return
 */
int FocusWindow::majorAxisDistanceToFarEdge(Direction dircetion, QRect source, QRect dest)
{
	return qMax(1, majorAxisDistanceToFarEdgeRaw(dircetion, source, dest));
}

/**
 * @brief ᷽Ե
 * @param dircetion
 * @param source
 * @param dest
 * @return
 */
int FocusWindow::majorAxisDistanceToFarEdgeRaw(Direction dircetion, QRect source, QRect dest)
{
	switch (dircetion)
	{
		case Up:
			return source.top() - dest.top();
		case Down:
			return dest.bottom() - source.bottom();
		case Left:
			return source.left() - dest.left();
		case Right:
			return dest.right() - source.right();
		default:
			return 0;
	}
}

/**
 * @brief 㸱᷽ϵľ(ĵľ)
 * @param direction
 * @param source
 * @param dest
 * @return
 */
int FocusWindow::minorAxisDistance(Direction direction, QRect source, QRect dest)
{
	switch (direction)
	{
		case Up:
		case Down:
			return qAbs((source.left() + source.width() / 2) - (dest.left() + dest.width() / 2));
		case Left:
		case Right:
			return qAbs((source.top() + source.height() / 2) - (dest.top() + dest.height() / 2));
		default:
			return 0;
	}
}

/**
 * @brief ۺϾ, 㹫ʽ 13 * major^2 + minor ^ 2(13ΪȨ)
 * @param direction
 * @param majorAxisDistance ᷽ľ
 * @param minorAxisDistance ᷽ľ
 * @return
 */
int FocusWindow::getWeightDistanceFor(int majorAxisDistance, int minorAxisDistance)
{
	return 13 * majorAxisDistance * majorAxisDistance + minorAxisDistance * minorAxisDistance;
}

/**
 * @brief жrect1rect2sourcedircetionǷ
 * @param dircetion 
 * @param source 
 * @param rect1 һ
 * @param rect2 ڶ
 * @return
 */
bool FocusWindow::beamBeats(Direction direction, QRect source, QRect rect1, QRect rect2)
{
	bool rect1InSrcBeam = beamsOverlap(direction, source, rect1);
	bool rect2InSrcBeam = beamsOverlap(direction, source, rect2);
	// rect2صrect1ص
	if (rect2InSrcBeam || !rect1InSrcBeam)
	{
		return false;
	}
	// rect1صrect2ص
	// 
	// rect2Ƿdirection
	if (!isToDirectionOf(direction, source, rect2))
	{
		return true;
	}

	// ˮƽһ
	if (direction == Left || direction == Right)
	{
		return true;
	}
	return (majorAxisDistance(direction, source, rect1)
			< majorAxisDistanceToFarEdge(direction, source, rect2));
}

/**
 * @brief жǷǸõĺѡ
 * @param direction 
 * @param focused  ǰ۽Ŀؼȫλ
 * @param focusable ǰ۽Ŀؼȫλ
 * @param curCandidate ǰѺѡȫλ
 * @return
 */
bool FocusWindow::isBetterCandidate(Direction direction, QRect focused, QRect focusable, QRect curCandidate)
{
	// ǰĿؼ(direction)
	if (!isCandidate(focused, focusable, direction))
	{
		return false;
	}
	// ѡؼ
	if (!isCandidate(focused, curCandidate, direction))
		return true;
	// ǰĿؼԭĺѡؼжԱ
	if (beamBeats(direction, focused, focusable, curCandidate))
	{
		return true;
	}
	// ǰѡؼ뵱ǰؼжԱ
	if (beamBeats(direction, focused, curCandidate, focusable))
	{
		return false;
	}

	// 㵱ǰؼ۽ؼۺϾǷСںѡؼ۽ؼۺϾ
	return (getWeightDistanceFor(majorAxisDistance(direction, focused, focusable),
			minorAxisDistance(direction, focused, focusable))
			< getWeightDistanceFor(majorAxisDistance(direction, focused, curCandidate),
			minorAxisDistance(direction, focused, curCandidate)));
}

/**
 * @brief ָһؼ
 * @param direction
 * @return
 */
QWidget* FocusWindow::getNextFocusWidget(Direction direction)
{
	focusableList = getAllFocusabelWidget();
	QWidget* nextFocus = nullptr;
	// ѡб
	QList<QWidget*> candidates;

	QWidget* focusedWidget = QApplication::focusWidget();
	if (!focusedWidget)
		return nextFocus;

	// 㵱ǰ۽ؼȫλ
	QRect focusedRect = QRect(focusedWidget->mapToGlobal(QPoint(0, 0)), focusedWidget->size());
	// 鹹һѡԭλ෴ƶһ
	QRect betterCandidateRect = focusedRect;
	switch (direction)
	{
		case Up:
			betterCandidateRect = QRect(QPoint(focusedRect.x(), focusedRect.y() + 1), focusedRect.size());
			break;
		case Down:
			betterCandidateRect = QRect(QPoint(focusedRect.x(), focusedRect.y() - 1), focusedRect.size());
			break;
		case Left:
			betterCandidateRect = QRect(QPoint(focusedRect.x() + 1, focusedRect.y()), focusedRect.size());
			break;
		case Right:
			betterCandidateRect = QRect(QPoint(focusedRect.x() - 1, focusedRect.y()), focusedRect.size());
			break;
		default:
			break;
	}
	// ѭȽϿؼλãҵкѡؼ
	for (int i = 0; i < focusableList.length(); i++)
	{
		QWidget* focusable = focusableList.at(i);
		// ɾ۽ؼǵǰýĿؼתȽ
		if (focusable == focusedWidget)
			continue;
		// ɾ۽ؼλתΪȫֵλ
		QRect focusableRect = QRect(focusable->mapToGlobal(QPoint(0, 0)), focusable->size());
		// ǷΪźѡ
		if (isBetterCandidate(direction, focusedRect, focusableRect, betterCandidateRect))
		{
			betterCandidateRect = focusableRect;
			nextFocus = focusable;
		}
	}
	return nextFocus;
}

/**
 * @brief ۽һؼ
 * @param direction
 */
void FocusWindow::focusNext(Direction direction)
{
	QWidget* nextFocus = getNextFocusWidget(direction);
	if (nextFocus)
	{
		nextFocus->setFocus();
	}
}

