/*****************************************************************
 * @file   FocusWindow.h
 * @brief  qt役ܹƶ࣬ڲʵȫandroidԴ뽹ƶ֡
 * ʹõʱҪ̳༴ɲдgetAllFocusabelWidget
 * @author luoxiang
 * @date   May 23 2024
****************************************************************/
#include <qwidget.h>
#ifndef FOCUS_WINDOW_H
#define FOCUS_WINDOW_H

namespace FW
{
	class FocusWindow
	{
	public:
		// ƶ
		enum Direction
		{
			Up,
			Down,
			Left,
			Right
		};
		void focusNext(Direction direction);

	protected:
		// 麯дԻȡǰпԻýĿؼ
		virtual QList<QWidget*> getAllFocusabelWidget() = 0;

	private:
		QList<QWidget*> focusableList;

	private:
		// 뽹ƶصĺ
		QWidget* getNextFocusWidget(Direction direction);
		bool isCandidate(QRect focused, QRect focusable, Direction direction);
		bool isBetterCandidate(Direction direction, QRect focused, QRect focusable, QRect curCandidate);
		bool beamBeats(Direction dircetion, QRect source, QRect rect1, QRect rect2);
		bool beamsOverlap(Direction direction, QRect rect1, QRect rect2);
		bool isToDirectionOf(Direction direction, QRect source, QRect dest);
		int majorAxisDistance(Direction direction, QRect source, QRect dest);
		int majorAxisDistanceRaw(Direction direction, QRect source, QRect dest);
		int minorAxisDistance(Direction direction, QRect source, QRect dest);
		int getWeightDistanceFor(int majorAxisDistance, int minorAxisDistance);
		int majorAxisDistanceToFarEdge(Direction dircetion, QRect source, QRect dest);
		int majorAxisDistanceToFarEdgeRaw(Direction dircetion, QRect source, QRect dest);
	};
}

#endif // !FOCUS_WINDOW_H


